
/***************************************************************************
*
*   Copyright (c) 1998, 1999 Timpanogas Research Group, Inc.
*   895 West Center Street
*   Orem, Utah  84057
*   jmerkey@timpanogas.com
*
*   This program is free software; you can redistribute it and/or modify it
*   under the terms of the GNU General Public License as published by the
*   Free Software Foundation, version 2, or any later version.
*
*   This program is distributed in the hope that it will be useful, but
*   WITHOUT ANY WARRANTY; without even the implied warranty of
*   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
*   General Public License for more details.
*
*   You are free to modify and re-distribute this program in accordance
*   with the terms specified in the GNU Public License.  The copyright
*   contained in this code is required to be present in any derivative
*   works and you are required to provide the source code for this
*   program as part of any commercial or non-commercial distribution.
*   You are required to respect the rights of the Copyright holders
*   named within this code.
*
*   jmerkey@timpanogas.com and TRG, Inc. are the official maintainers of
*   this code.  You are encouraged to report any bugs, problems, fixes,
*   suggestions, and comments about this software to jmerkey@timpanogas.com
*   or linux-kernel@vger.rutgers.edu.  New releases, patches, bug fixes, and
*   technical documentation can be found at www.timpanogas.com.  TRG will
*   periodically post new releases of this software to www.timpanogas.com
*   that contain bug fixes and enhanced capabilities.
*
*   Original Authorship      :
*      source code written by Jeff V. Merkey, TRG, Inc.
*
*   Original Contributors    :
*      Jeff V. Merkey, TRG, Inc.
*      Darren Major, TRG, Inc.
*      Alan Cox, RedHat Software, Inc.
*
****************************************************************************
*
*
*   AUTHOR   :  Jeff V. Merkey (jmerkey@timpanogas.com)
*   FILE     :  GLOBALS.C
*   DESCRIP  :  FENRIS Global Code Variables
*   DATE     :  November 1, 1998
*
*
***************************************************************************/

#include "globals.h"

ULONG MajorVersion = 0, MinorVersion = 0, BuildVersion = 0;
ULONG exitFlag = 0;
ULONG consoleHandle = 0;
ULONG MaximumNumberOfVolumes = 0;
ULONG NumberOfVolumes = 0;
ULONG TotalDisks = 0;
ULONG TotalNWParts = 0;
ULONG MaximumDisks = 0;
ULONG MaximumNWParts = 0;

ULONG MemoryAllocated = 0;
ULONG MemoryFreed = 0;
ULONG MemoryInUse = 0;

ULONG PagedMemoryAllocated = 0;
ULONG PagedMemoryFreed = 0;
ULONG PagedMemoryInUse = 0;

NWDISK *SystemDisk[MAX_DISKS];
VOLUME *VolumeTable[MAX_VOLUMES];
ULONG VolumeMountedTable[MAX_VOLUMES];
ULONG InstanceCounter = 1;
BYTE *ZeroBuffer = 0;
ULONG (*RemirrorProcessPtr)(ULONG) = 0;

ULONG DataLRUActive = 0;
LRU_HANDLE DataLRU;

ULONG HOTFIX_TRACK_OFFSET[MULTI_TRACK_COUNT]=
{
    HOTFIX_LOCATION_0, HOTFIX_LOCATION_1, HOTFIX_LOCATION_2,
    HOTFIX_LOCATION_3
};

ULONG MIRROR_TRACK_OFFSET[MULTI_TRACK_COUNT]=
{
    MIRROR_LOCATION_0, MIRROR_LOCATION_1, MIRROR_LOCATION_2,
    MIRROR_LOCATION_3
};

ULONG VOLTABLE_TRACK_OFFSET[MULTI_TRACK_COUNT]=
{
    VOLUME_TABLE_LOCATION_0, VOLUME_TABLE_LOCATION_1, VOLUME_TABLE_LOCATION_2,
    VOLUME_TABLE_LOCATION_3
};

#if (LINUX)

ULONG DiskDevices[MAX_DISKS] =
{
    0x0300,  // hda  IDE 1st Adapter
    0x0340,  // hdb
    0x1600,  // hdc  IDE 2nd Adapter
    0x1640,  // hdd
    0x2100,  // hde  IDE 3rd Adapter
    0x2140,  // hdf
    0x2200,  // hdg  IDE 4th Adapter
    0x2240,  // hdh
    0x2400,  // eda  MCA ESDI
    0x2440,  // edb
    0x0800,  // sda  SCSI 0-16
    0x0810,  // sdb
    0x0820,  // sdc
    0x0830,  // sdd
    0x0840,  // sde
    0x0850,  // sdf
    0x0860,  // sdg
    0x0870,  // sdh
    0x0880,  // sdi
    0x0890,  // sdj
    0x08a0,  // sdk
    0x08b0,  // sdl
    0x08c0,  // sdm
    0x08d0,  // sdn
    0x08e0,  // sdo
    0x08f0,  // sdp
};


#endif

void InitNWFS(void)
{
    register ULONG ccode;

    ccode = InitializeLRU(&DataLRU, "Data LRU", WRITE_BACK_LRU,
			  MAX_VOLUME_LRU_BLOCKS,
			  MIN_VOLUME_LRU_BLOCKS);
    if (!ccode)
       DataLRUActive = TRUE;

    ZeroBuffer = NWFSIOAlloc(65536, DISKBUF_TAG);
    if (!ZeroBuffer)
       return;
    NWFSSet(ZeroBuffer, 0, 65536);

    return;
}

